<?php
/*
 Plugin Name: NinjaTeam WP XSS Patch
 Plugin URI: http://ninjateam.org/
 Description: Fixing WordPress XSS bugs.
 Version: 1.0
 Author: NinjaTeam
 Author URI: http://ninjateam.org/
 */


/**
 * Remove special chars from string, like html tags, ', " etc... Using strip_tags and htmlentities functions
 *
 * @param  String $str String be filted
 *
 * @return String
 */
function njt_remove_special_chars($str)
{
    $str = strip_tags($str);
    $str = htmlentities($str, ENT_QUOTES, 'UTF-8');
    return $str;
}

/*
 * Filters the comment content before it is updated in the database.
 */
add_filter('comment_save_pre', 'njt_filter_comment_save_pre');
function njt_filter_comment_save_pre($comment_content)
{
    return njt_remove_special_chars($comment_content);
}

/* 
 * Fires after a comment is retrieved.
 */
add_filter('get_comment', 'njt_filter_get_comment');
function njt_filter_get_comment($_comment)
{
    $_comment->comment_content = njt_remove_special_chars($_comment->comment_content);
    return $_comment;
}

/*
 * Before inserting or updating to database.
 */
add_filter('wp_insert_post_data', 'njt_filter_wp_insert_post_data', 10, 2);
function njt_filter_wp_insert_post_data($data, $postarr)
{
    $data['post_title'] = njt_remove_special_chars($data['post_title']);
    return $data;
}
